#include "Archive.h"

Archive::Archive(Parameter& para){

    ifstream fin;
  
	archiveSize = para.getPopulationSize();
	ranking = new SPEA2ranking(para);
	selector = new TournamentSelection();
	pena = new NSGAIIpenalty();

	if(para.getFInitialPopulation()){
	  fin.open("design_variable.ini");
	  if(!fin){
	    cerr << __FILE__ << ":(" << __LINE__ << ") can't open file design_variable.ini"<< endl;
	    exit(1);
	  }
	}

	//η
	objarchive.resize(archiveSize);

	for(int i=0;i<archiveSize;i++){
		objarchive[i] = *(new Individual());	
	  }
	
	if(para.getFInitialPopulation()){
	  for(int i=0;i<archiveSize;i++){
		objarchive[i] = *(new Individual(para, fin));	
		if(fin.fail()) break;
	  }
	  
	} 
	
	
	//ɾ
	for(int i=0;i<archiveSize;i++){
		objarchive[i].evaluation();
	}

	fin.close();
	
}
		
Individual* Archive::getobjArchive(int i){
	return &objarchive[i];
}

Population Archive::getSearchPopulation()
{
  Parameter *parameter = &(Parameter::getInstance());
  Population tmpPopulation;
  
  //ᥤƥˤ꿷õ콸Ĥ
  matingSelection(tmpPopulation);
  return tmpPopulation;
}

void Archive::updateArchive(Population& pop){
	exeranking(pop);
	penalty(pop);
	preserveArchive(pop);
}

//콸ĤȣĤΥ֤򺮤ƥ󥭥
void Archive::exeranking(Population& pop){
	ranking->spea2ranking(pop.getPopulation(),objarchive);
}

//¹ԲǽΰϤ줿ΤФƥڥʥƥͿ
void Archive::penalty(Population& pop){
	//郎Ȥ
	if(Parameter::getInstance().getfunc()->getconstraintNum()>0){
		vector<Individual> poparc;
		poparc.resize(0);
		for(int i=0;i<archiveSize;i++){
			poparc.push_back(*pop.getPopulation(i));
		}
		for(int i=0;i<archiveSize;i++){
			poparc.push_back(objarchive[i]);
		}

		pena->penalty(poparc);
	
		for(int i=0;i<archiveSize;i++){
			pop.getPopulation(i)->setfitness(poparc[i].getfitness());
		}
		for(int i=0;i<archiveSize;i++){
			objarchive[i].setfitness(poparc[i+archiveSize].getfitness());
		}

	}
	//郎̵Ȥ
	else{
		//󥯤ͤ򤽤ΤޤfitnessȤ
		for(int i=0;i<archiveSize;i++){
			pop.getPopulation(i)->setfitness((double) pop.getPopulation(i)->getrank());
		}
		for(int i=0;i<archiveSize;i++){
			objarchive[i].setfitness((double) objarchive[i].getrank());
		}

	}	
}

//꡼¸
void Archive::preserveArchive(Population& pop){

	int tmpSize = pop.getPopulation().size()+objarchive.size();
	vector<Individual> tmp;
	tmp.resize(tmpSize);
	for(int i=0;i<pop.getPopulation().size();i++){
		tmp[i]=*pop.getPopulation(i);
		
	}
	for(int i=pop.getPopulation().size();i<objarchive.size()+pop.getPopulation().size();i++){
		tmp[i]=objarchive[i-pop.getPopulation().size()];
	}


	sort(tmp.begin(),tmp.end());
	fitness0num=0;
	//󥯣θΤο롥
	for(int i=0;i<tmp.size();i++){
		if(tmp[i].getfitness()==0){
			fitness0num++;
		}
	}

	objarchive.resize(archiveSize);

	if(fitness0num<=archiveSize){//ο֥ʲʤ
		//fitnessΤ褤ˤΤޤޤ줾Υ֤
		for(int i=0;i<archiveSize;i++){
			objarchive[i]=tmp[i];
		}
	}		
	else{//ο֥ۤ
		vector<Individual> over;	//֥ʾ
		over.resize(fitness0num);
		for(int i=0;i<fitness0num;i++){
			over[i]=tmp[i];	//Ǽ
		}
		truncation(over);//üڤ
	}
}

//ᥤƥ
void Archive::matingSelection(Population& pop){
	selector->select(*this,pop);
}

//üڤ
void Archive::truncation(vector<Individual>& fitness0){

	vector<Individual> tmp;	//߷ѿ֤سǼ뤿
	tmp.resize(fitness0.size());
	for(int i=0;i<fitness0.size();i++){
		tmp[i]=fitness0[i];	//ԡƤ
	}
	
	truncator = new Truncation(fitness0);//üڤꥤ󥹥
	truncator->objtruncation(fitness0); //Ūüڤ
	objarchive.resize(archiveSize);
	for(int i=0;i<archiveSize;i++){
		objarchive[i]=fitness0[i];//̤Ǽ
	}		
	delete truncator;	
}

