#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;

#include "RandomGenerator.h"
#include "Individual.h"
#include "Parameter.h"

#ifndef _CROSSOVER_H_
#define _CROSSOVER_H_

//============================================
//	class Crossover
//============================================
class Individual;
class Crossover{
public:
	
	Crossover(){};
	
	virtual void crossover(Individual& a,Individual& b) = 0;
};

//============================================
//	class nPointCrossover
//============================================
class nPointCrossover : public Crossover{
public:

	nPointCrossover();
	
	void crossover(Individual& a,Individual& b);
	static Crossover& getInstance();
	
private:
	
	double crossoverRate;
	int numCrossover;
	int geneLength;
	RandomGenerator *randomGenerator;
	mutable vector<int> crossoverTable;
	
	void getCrossoverPoint(Individual& parent1, Individual& parent2,vector<int>& crossoverPoint);
	void createCrossoverTable();
	void crossoverOnePair(Individual& parent1, Individual& parent2, vector<int> crossoverPoint);
};

#endif
