#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;
#include "Individual.h"
#include "Parameter.h"

#ifndef _OFFSPRINGGENERATOR_H_
#define _OFFSPRINGGENERATOR_H_

class Individual;

//============================================
//	class OffspringGenerator
//============================================
class OffspringGenerator{
public:
	
	OffspringGenerator(){
		randomGenerator = &RandomGenerator::getInstance();
	 	parameter = &Parameter::getInstance();
		mating.resize(0);
		tmp.resize(2);
		pointer=Parameter::getInstance().getPopulationSize()-1;
	};
	
	//٤ΤƱΤ򺵤褦˥Ȥ롥(˵)
	virtual void makePairs(vector<Individual>& population) = 0;
	//ȸ˶᤯ΤƱΥåե뤹᥽å
	void neighborhood_shuffle();
	void getChild(vector<Individual>& parents);
	vector<Individual>& getParents();
	Individual& getOneChild(int i){
		return tmp[i];
	}
	
protected:
	int pointer;
	Parameter* parameter;
	RandomGenerator *randomGenerator;
	
	//餫ν¤ؤ줿η
	vector<Individual> mating;
	//PopulationϤ
	vector<Individual> tmp;

	//򥷥åե뤹
	void shuffle_indiv(int start,int end,vector<Individual>& population);
	

};

//============================================
//	class ObjectiveNeighborhood
//============================================
class ObjectiveNeighborhoodSort : public OffspringGenerator{
public:

	ObjectiveNeighborhoodSort(int generation);
	//ŪؿǶᤤΤƱΤ¤٤
	void makePairs(vector<Individual>& population);	

private:
	int generation;
	//Ūؿ˸򥽡
	void sort_by_objective(int objnum,int first,int end,vector<Individual>& pop);
};

//============================================
//	class NormalCrossoverSort
//============================================
class NormalCrossoverSort : public OffspringGenerator{
public:

	NormalCrossoverSort(){
	};
	//η̤˥
	void makePairs(vector<Individual>& population);	

private:
	
};
#endif //_OFFSPRINGGENERATOR_H_
